/*******************************************************************************
 *	@file			DLShow.cpp
 *	@brief			DirectX Library
 *
 *	@author			ohwhsmm7
 *
 *	@date			24-May-2011(Tue)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "DLShow.h"
#include "_DShowLib\\_DShowLib.h"
#ifdef	_DEBUG
	#pragma comment ( lib, "_DShowLib\\strmbasd.lib" )
#else	// _DEBUG
	#pragma comment ( lib, "_DShowLib\\strmbase.lib" )
#endif	// _DEBUG
#pragma comment ( lib, "_DShowLib\\_DShowLib.lib" )


/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// O[oϐ-----------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@fn				CDLMovie::CDLMovie( void )
 *	@retval			none						Ȃ
 *	@brief			RXgN^
 ******************************************************************************/
CDLMovie::CDLMovie( void )
{
}

/*******************************************************************************
 *	@fn				CDLMovie::~CDLMovie( void )
 *	@retval			none						Ȃ
 *	@brief			fXgN^
 ******************************************************************************/
CDLMovie::~CDLMovie( void )
{
}

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@fn				CDLShow::CDLShow( void )
 *	@retval			none						Ȃ
 *	@brief			RXgN^
 ******************************************************************************/
CDLShow::CDLShow( void )
	: m_hWnd()
	, m_lpD3DDev( NULL )

	, m_CMovie()
{
}

/*******************************************************************************
 *	@fn				CDLShow::~CDLShow( void )
 *	@retval			none						Ȃ
 *	@brief			fXgN^
 ******************************************************************************/
CDLShow::~CDLShow( void )
{
	End();
}

/*******************************************************************************
 *	@fn				int CDLShow::Init( const HWND& hWnd,
 *									   const LPDIRECT3DDEVICE9 &lpD3DDev )
 *	@param[in]		hWnd						EChEnh
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			
 ******************************************************************************/
int CDLShow::Init( const HWND& hWnd,
				   const LPDIRECT3DDEVICE9 &lpD3DDev )
{
	HRESULT hr = S_OK;
	m_hWnd = hWnd;
	m_lpD3DDev = lpD3DDev;

	_DShowInit( m_lpD3DDev );
	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLShow::End( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			I
 ******************************************************************************/
int CDLShow::End( void )
{
	_DShowEnd();
	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLShow::Update( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			ʍXV
 *					{ PresentImage ōs鏈
 ******************************************************************************/
int CDLShow::Update( void )
{
	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLSound::LoadMov( const LPWSTR& szName,
 *										   const int &nNum,
 *										   D3DTEXTURE* pD3DTex )
 *	@param[in]		szName						t@C
 *	@param[in]		nNum						ԍ
 *	@param[in]		pD3DTex						eNX`\
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			[r[ǂݍ
 ******************************************************************************/
int CDLShow::LoadMov( const LPWSTR& szName,
					  const int &nNum,
					  D3DTEXTURE* pD3DTex )
{
	_ASSERT( nNum < MOVIE_MAX && "LoadMov()" );

	HRESULT hr = S_OK;
	_DShowLoadMov( szName, nNum, static_cast<void*>( pD3DTex ) );

	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLShow::RemoveMov( const int &nNum )
 *	@param[in]		nNum						ԍ
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			[r[
 ******************************************************************************/
int CDLShow::RemoveMov( const int &nNum )
{
	_ASSERT( nNum < MOVIE_MAX && "RemoveMov()" );

	_DShowStop( nNum );
	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLShow::RemoveALL( void )
 *	@param[in]		nNum						ԍ
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			fޑS
 ******************************************************************************/
int CDLShow::RemoveALL( void )
{
	for( int i = 0; i < MOVIE_MAX; i++ )
		RemoveMov( i );
	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLShow::Play( const int &nNum )
 *	@param[in]		nNum						ԍ
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			[r[Đ
 ******************************************************************************/
int CDLShow::Play( const int &nNum )
{
	_ASSERT( nNum < MOVIE_MAX && "Play()" );

	_DShowPlay( nNum );
	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLShow::Stop( const int &nNum )
 *	@param[in]		nNum						ԍ
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			[r[~
 ******************************************************************************/
int CDLShow::Stop( const int &nNum )
{
	_ASSERT( nNum < MOVIE_MAX && "Stop()" );

	_DShowStop( nNum );
	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLShow::Loop( const int &nNum )
 *	@param[in]		nNum						ԍ
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			[r[[v
 ******************************************************************************/
int CDLShow::Loop( const int &nNum )
{
	_ASSERT( nNum < MOVIE_MAX && "Loop()" );

	_DShowLoop( nNum );
	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLShow::GetRate( const int &nNum,
 *										  double &dRate )
 *	@param[in]		nNum						ԍ
 *	@param[in]		dRate						Đ[g
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			[r[̍Đ[g擾
 ******************************************************************************/
int CDLShow::GetRate( const int &nNum, double &dRate )
{
	_ASSERT( nNum < MOVIE_MAX && "GetRate()" );

	_DShowGetRate( nNum, dRate );
	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLShow::GetDuration( const int &nNum,
 *											  double &refLen )
 *	@param[in]		nNum						ԍ
 *	@param[in]		refLen						
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			[r[̒擾
 ******************************************************************************/
int CDLShow::GetDuration( const int &nNum, double &refLen )
{
	_ASSERT( nNum < MOVIE_MAX && "GetDuration()" );

	_DShowGetDuration( nNum, refLen );
	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLShow::PutCurPos( const int &nNum,
 *											double &refLen )
 *	@param[in]		nNum						ԍ
 *	@param[in]		refLen						Đʒuw
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			[r[̍ĐJnʒuw
 ******************************************************************************/
int CDLShow::PutCurPos( const int &nNum, double &refLen )
{
	_ASSERT( nNum < MOVIE_MAX && "PutCurPos()" );

	_DShowPutCurPos( nNum, refLen );
	return TRUE;
}

}	// namespace	DL
